<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBorderCrossing ArrayType
 * @subpackage Arrays
 */
class ArrayOfBorderCrossing extends AbstractStructArrayBase
{
    /**
     * The BorderCrossing
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BorderCrossing[]
     */
    public $BorderCrossing;
    /**
     * Constructor method for ArrayOfBorderCrossing
     * @uses ArrayOfBorderCrossing::setBorderCrossing()
     * @param \StructType\BorderCrossing[] $borderCrossing
     */
    public function __construct(array $borderCrossing = array())
    {
        $this
            ->setBorderCrossing($borderCrossing);
    }
    /**
     * Get BorderCrossing value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BorderCrossing[]|null
     */
    public function getBorderCrossing()
    {
        return isset($this->BorderCrossing) ? $this->BorderCrossing : null;
    }
    /**
     * This method is responsible for validating the values passed to the setBorderCrossing method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBorderCrossing method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBorderCrossingForArrayConstraintsFromSetBorderCrossing(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfBorderCrossingBorderCrossingItem) {
            // validation for constraint: itemType
            if (!$arrayOfBorderCrossingBorderCrossingItem instanceof \StructType\BorderCrossing) {
                $invalidValues[] = is_object($arrayOfBorderCrossingBorderCrossingItem) ? get_class($arrayOfBorderCrossingBorderCrossingItem) : sprintf('%s(%s)', gettype($arrayOfBorderCrossingBorderCrossingItem), var_export($arrayOfBorderCrossingBorderCrossingItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The BorderCrossing property can only contain items of type \StructType\BorderCrossing, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set BorderCrossing value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\BorderCrossing[] $borderCrossing
     * @return \ArrayType\ArrayOfBorderCrossing
     */
    public function setBorderCrossing(array $borderCrossing = array())
    {
        // validation for constraint: array
        if ('' !== ($borderCrossingArrayErrorMessage = self::validateBorderCrossingForArrayConstraintsFromSetBorderCrossing($borderCrossing))) {
            throw new \InvalidArgumentException($borderCrossingArrayErrorMessage, __LINE__);
        }
        if (is_null($borderCrossing) || (is_array($borderCrossing) && empty($borderCrossing))) {
            unset($this->BorderCrossing);
        } else {
            $this->BorderCrossing = $borderCrossing;
        }
        return $this;
    }
    /**
     * Add item to BorderCrossing value
     * @throws \InvalidArgumentException
     * @param \StructType\BorderCrossing $item
     * @return \ArrayType\ArrayOfBorderCrossing
     */
    public function addToBorderCrossing(\StructType\BorderCrossing $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BorderCrossing) {
            throw new \InvalidArgumentException(sprintf('The BorderCrossing property can only contain items of type \StructType\BorderCrossing, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->BorderCrossing[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\BorderCrossing|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\BorderCrossing|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\BorderCrossing|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\BorderCrossing|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\BorderCrossing|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BorderCrossing
     */
    public function getAttributeName()
    {
        return 'BorderCrossing';
    }
}
